# <Copyright and license information goes here.>
require 'plasma_applet'
require "pp" 
module Taskiller
  class Main < PlasmaScripting::Applet
    slots 'sourceAdded(QString)','dataUpdated(QString, Plasma::DataEngine::Data)',"internalTogglePopup()"
    def initialize parent
      super parent
    end      
    def init
      self.has_configuration_interface = false
      self.aspect_ratio_mode = Plasma::Square
      connect(@de=dataEngine("tasks"),  SIGNAL('sourceAdded(QString)'),
              self, SLOT('sourceAdded(QString)'))
      connect(self, SIGNAL('activate()'), self,SLOT("internalTogglePopup()"))
    end
    def sourceAdded(window=nil)
      @de.sources.each do |c|
	@de.query(c)
      end
    end
    def mousePressEvent event
      d=Plasma::Dialog.new
      la=Qt::VBoxLayout.new(d)
      l=Qt::ListWidget.new
      l.connect(SIGNAL("itemClicked(QListWidgetItem*)")) do |i|
	id=i.text.split(" ")[0]
	puts id
	pp @de.sources
	service=dataEngine("tasks").serviceForSource(dataEngine("tasks").sources.first)
	pp service.operationNames 
	service.startOperationCall(service.operationDescription("close"))
	#pid=`xprop -id 0x#{"%x"%id}`
	#`wmctrl -i -c #{id}`
      end
      la.addWidget(l)
      @de.sources.each do |c|
	l.addItem(c+" "+@de.query(c)["name"].toString)
      end      
      d.show
    end
  end
end